﻿Class Canvas : Implements Api.Canvas
    Dim _queue As Queue
    Dim _e1 As MouseEventArgs

    Private Sub Panel1_MouseDown(ByVal sender As Object, ByVal e1 As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseDown
        Me._e1 = e1
    End Sub

    Private Sub Panel1_MouseMove(ByVal sender As Object, ByVal e2 As MouseEventArgs) Handles Panel1.MouseMove
        If e2.Button <> Windows.Forms.MouseButtons.None Then
            Me._queue.Enqueue(New InternalEvents.Canvas_MouseMove(Me._e1, e2, Me, Tablet.Instance(e2.GetHashCode())))
            Me._e1 = e2
        End If
    End Sub

    Private Sub Panel1_MouseUp(ByVal sender As Object, ByVal e2 As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseUp
        Me._queue.Enqueue(New InternalEvents.Canvas_MouseMove(Me._e1, e2, Me, Tablet.Instance(e2.GetHashCode())))
        Me._e1 = Nothing
    End Sub

    Public Sub Draw(ByVal i As System.Drawing.Image, ByVal location As System.Drawing.Point) Implements Api.Canvas.Draw
        Dim g = Me.Panel1.CreateGraphics()
        g.DrawImage(i, location)
        g.Dispose()
        Me.Invalidate()
    End Sub

    Sub New()

        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me._queue = New Queue
    End Sub

End Class
