Namespace InternalEvents

    Class Canvas_MouseMove : Inherits InternalEvent
        Dim _tablet As Tablet

        Property Tablet()
            Get
                Tablet = Me._tablet
            End Get
            Set(ByVal value)
                Me._tablet = value
            End Set
        End Property

        Overrides Sub Invoke()
            Me._tablet.Invoke()
        End Sub

        Sub New(ByVal e1 As MouseEventArgs, ByVal e2 As MouseEventArgs, ByVal c As Api.Canvas, ByVal t As Tablet)
            Dim s = New Plugin.Strokes.NullStroke
            s.StrokePoints.Add(New Plugin.StrokePoint(e1.Location, 1))
            s.StrokePoints.Add(New Plugin.StrokePoint(e2.Location, 1))
            Me._tablet = t
            Me._tablet.Canvas = c
            Me._tablet.Stroke = s
        End Sub
    End Class

End Namespace