﻿Class Queue ' : 別スレッド可能
    Dim _events As Queue(Of InternalEvent)
    Dim _timer As System.Threading.Timer

    Sub Enqueue(ByVal e As InternalEvent)
        Me._events.Enqueue(e)
    End Sub

    Sub Timer(ByVal state As Object)
        If Me._events.Count > 0 Then Me._events.Dequeue().Invoke()
        Me._timer.Change(0, Threading.Timeout.Infinite)
    End Sub

    Sub New()
        Me._events = New Queue(Of InternalEvent)
        Me._timer = New System.Threading.Timer(AddressOf Me.Timer, Nothing, 0, Threading.Timeout.Infinite)
    End Sub

End Class
